{****************************************************************************
//                            File MESSAGES.PAS
//
//                       User text messages module
//
//      Copyright (c) 1994, 1999 Dmitry Stefankov. All rights reserved.
//
//****************************************************************************
//
//   $Source: D:/BP70/SOURCE/TYPIST/RCS/messages.pas $
//  $RCSfile: messages.pas $ 
//   $Author: dstef $ 
//     $Date: 1999/01/03 17:55:21 $ 
// $Revision: 1.1 $ 
//   $Locker: dstef $ 
//
//      $Log: messages.pas $
//      Revision 1.1  1999/01/03 17:55:21  dstef
//      Initial revision
// 
//
//****************************************************************************}


{-----------------------------------------------------------------------}
{ PROJECT               MICROSOFT/IBM DISK OPERATING SYSTEM UTILITIES   }
{                       (COMMERCIAL PURPOSE)                            }
{ LIBRARY               TEXT_PROCESSING                                 }
{ MODULE                INTELLECTUAL_TYPIST                             }
{ FILE NAME             MESSAGES.PAS                                    }
{ PURPOSE               Text messages for user interface                }
{ VERSION               0.01                                            }
{ DATE                  13-Sep-94                                       }
{ DESIGN                Dmitry Stefankov                                }
{ IMPLEMENTATION        Dmitry Stefankov                                }
{ COMPANY               Freelance Software Engineer                     }
{ ADDRESS               Isakowskogo str, 4-2-30                         }
{                       Moscow, 123181                                  }
{                       Russia                                          }
{                       Tel. 007 (095) 944-6304                         }
{ COPYRIGHT NOTICE      Copyright (C) 1987-1994, Dmitry Stefankov       }
{ RESTRICTED RIGHTS     FOR INTERNAL USE ONLY.                          }
{                       THIS FILE CONTAINS PROPRIETARY AND CONFIDENTIAL }
{                       INFORMATION. COPYING AND REPRODUCTION WITHOUT   }
{                       PRIOR WRITTEN PERMISSION IS PROHIBITED.         }
{ COMPUTER              IBM PC or compatible                            }
{ OPERATING SYSTEM      MS/PC-DOS Version 3.30 or higher                }
{ COMPILER              Turbo Pascal Version 7.0                        }
{                       (Borland International Inc.)  or compatible     }
{ ASSEMBLY LANGUAGE     Microsoft MASM 5.10 or compatible               }
{ LINKER                Turbo Pascal internal                           }
{ ARGUMENTS             None                                            }
{ RETURN                None                                            }
{ REQUIRES              Source Code Files                               }
{                       None                                            }
{                       Object Code Files                               }
{                       STRINGS.TPU    (Turbo Strings unit)             }
{                       GLOBALS.TPU    (Global public definitions)      }
{                       Project Maintence Files                         }
{                       TYPIST.MAK     (auto compiling & linking)       }
{ NATURAL LANGUAGE      English Language                                }
{ SPECIAL               None                                            }
{ DESCRIPTION           None                                            }
{ REVISION HISTORY      Dima Stefankov (DS)                             }
{                       0.01   13-Sep-94  DS  initial release           }
{-----------------------------------------------------------------------}



UNIT
    Messages;


INTERFACE


USES
    Strings,
    Globals;


FUNCTION   _fnsTextMessageByIndex(dwMsgIndex : System.Word) : STRING;


IMPLEMENTATION



CONST

  {* index for table access *}

    aTableIndexMin   =  1;
    aTableIndexMax   =  569;

    gszMsgIdxTable     :  ARRAY[Globals.aMinLanguage..Globals.aMaxLanguage]  OF
                          ARRAY[aTableIndexMin..aTableIndexMax]  OF System.PChar =
        ((
         {001}  ('Bad message index found.'),
         {002}  ('None language not installed.'),
         {003}  ('English language not supported in this implementation.'),
         {004}  ('Russian language not supported in this implementation.'),
         {005}  ('Requires Intel 80186 processor or higher.'),
         {006}  ('Nothing done.'),
         {007}  ('Done.'),
         {008}  ('INTELLECTUAL TYPIST'),
         {009}  ('Dima Stefankov'),
         {010}  ('Copyright (c)'),
         {011}  ('I-Typist'),
         {012}  ('Version'),
         {013}  ('I-Typist: '),
         {014}  ('!Exit!=>'),
         {015}  ('!DEBUG-INFO!'),
         {016}  ('Use for more help:'),
         {017}  ('or'),
         {018}  ('Press <ENTER> to continue or type any string to abort:'),
{$IFDEF   EngVer}
         {019}  ('Aborted by user.'),
         {020}  ('Open help file'),
         {021}  ('Could not found help file.'),
         {022}  ('Help file was displayed.'),
         {023}  ('Help output done.'),
         {024}  ('Save current interrupt vectors.'),
         {025}  ('Restore current interrupt vectors.'),
         {026}  ('Don''t restore current interrupt vectors.'),
         {027}  ('Bad boolean parameter found in string'),
         {028}  ('Bad word parameter found in string'),
         {029}  ('Bad range for word parameter found in string'),
         {030}  ('Bad byte parameter found in string'),
         {031}  ('Bad range for byte parameter found in string'),
         {032}  ('Bad string parameter found in string'),
         {033}  ('Too large string for parameter found in string'),
         {034}  ('No switch found in string'),
         {035}  ('Unsupported switch found in string'),
         {036}  ('Sorting of user dictionary.'),
         {037}  ('abbreviation'),
         {038}  ('expression'),
         {039}  ('File'),
         {040}  ('diagnostic dump'),
         {041}  ('Empty dictionary found.'),
         {042}  ('Total entries per dictionary found'),
         {043}  ('character'),
         {044}  ('count'),
         {045}  ('Total for this table'),
         {046}  ('User dictionary'),
         {047}  ('Statistics for FA frequency table'),
         {048}  ('Statistics for BA frequency table'),
         {049}  ('Statistics for FE frequency table'),
         {050}  ('Statistics for BE frequency table'),
         {051}  ('Statistics for AS frequency table'),
         {052}  ('Statistics for ES frequency table'),
         {053}  ('Bad symbol(s) for user init search flags.'),
         {054}  ('Duplicate abbreviation found as'),
         {055}  ('Undefined type of search of keyword for '),
         {056}  ('Bad numeric parameter in line'),
         {057}  ('Bad syntax for numeric parameter in line'),
         {058}  ('Bad syntax for user substring in line'),
         {059}  ('Invalid hotkey definition statement in line'),
         {060}  ('Invalid keyboard scan code line'),
         {061}  ('Invalid hotkey definition in line'),
         {062}  ('Invalid sorting order type in line'),
         {063}  ('Parse configuration file'),
         {064}  ('Cannot open config file.'),
         {065}  ('Error reading config file.'),
         {066}  ('Parse section for'),
         {067}  ('Invalid section statement in line'),
         {068}  ('Invalid subsection statement in line'),
         {069}  ('Invalid parameter keyword in line'),
         {070}  ('Empty user character <from> in line'),
         {071}  ('Skipped keyword'),
         {072}  ('in line'),
         {073}  ('Empty user abbreviation in line'),
         {074}  ('Limit of delimiters was reached in line'),
         {075}  ('Empty user dictionary expression in line'),
         {076}  ('Invalid section number found.'),
         {077}  ('Empty configuration file.'),
         {078}  ('Check multiplex channel'),
         {079}  ('for availability.'),
         {080}  ('This multiplex channel found free.'),
         {081}  ('This multiplex channel found unavailable.'),
         {082}  ('Search for free multiplex channel.'),
         {083}  ('No free multiplex channel found.'),
         {084}  ('First free multiplex channel'),
         {085}  ('Search for already installed memory copy.'),
         {086}  ('No resident part found.'),
         {087}  ('Multiplex channel for resident part'),
         {088}  ('Invalid environment handle found.'),
         {089}  ('Call to get environment list failed.'),
         {090}  ('Search environment list for first free handle.'),
         {091}  ('Get current mode call failed.'),
         {092}  ('unknown mode'),
         {093}  ('Get raw user input call failed.'),
         {094}  ('Current environment handle'),
         {095}  ('Call to get current environment handle failed.'),
         {096}  ('Call to get current environment settings failed.'),
         {097}  ('Get search user input call failed.'),
         {098}  ('Bad search input parameters for entry.'),
         {099}  ('Get replace buffer call failed.'),
         {100}  ('Set new filter flag call failed.'),
         {101}  ('Set old intvec call failed.'),
         {102}  ('Get old intvec call failed.'),
         {103}  ('Set new kbd mode call failed.'),
         {104}  ('Alloc new free space call failed.'),
         {105}  ('Insufficient free memory in pool.'),
         {106}  ('Free memory info call failed.'),
         {107}  ('Free space pool'),
         {108}  ('Pool size'),
         {109}  ('was used'),
         {110}  ('List of available dictionaries.'),
         {111}  ('Environment list: available handles'),
         {112}  ('link address'),
         {113}  ('Environment handle'),
         {114}  ('description table'),
         {115}  ('Free environment handles'),
         {116}  ('Add to environment list handle'),
         {117}  ('Environment table full. Remove unused dictionaries from memory.'),
         {118}  ('Was removed from environment list the handle'),
         {119}  ('Unable to remove unused environment from memory table.'),
         {120}  ('Set new current environment handle'),
         {121}  ('Call to select new environment handle failed.'),
         {122}  ('Call to get current status failed.'),
         {123}  ('Reset current environment call failed.'),
         {124}  ('Reset current free space ptr call failed.'),
         {125}  ('Call to patch multiplex interface failed.'),
         {126}  ('Node options'),
         {127}  ('raw dump of compressed static head link table'),
         {128}  ('bitmap byte'),
         {129}  ('chars'),
         {130}  ('bitcount'),
         {131}  ('Total present characters'),
         {132}  ('node abbreviation string'),
         {133}  ('Node at address'),
         {134}  ('table index'),
         {135}  ('Number bytes occupied by this node'),
         {136}  ('node options'),
         {137}  ('padding zero'),
         {138}  ('compressed'),
         {139}  ('FA-link present'),
         {140}  ('BA-link present'),
         {141}  ('FE-link present'),
         {142}  ('BE-link present'),
         {143}  ('AS-link present'),
         {144}  ('ES-link present'),
         {145}  ('node FA link field'),
         {146}  ('node BA link field'),
         {147}  ('node FE link field'),
         {148}  ('node BE link field'),
         {149}  ('node AS link field'),
         {150}  ('node ES link field'),
         {151}  ('node access count'),
         {152}  ('node hit count'),
         {153}  ('node abbreviation size'),
         {154}  ('node expression size'),
         {155}  ('node expression string'),
         {156}  ('Total entries found'),
         {157}  ('Total bytes for this dictionary w/o tables = '),
         {158}  ('Dump environment.'),
         {159}  ('Current environment with dictionary'),
         {160}  ('Dump collected statistics for each node.'),
         {161}  ('Dump environment options/settings.'),
         {162}  ('Dump dictionary.'),
         {163}  ('Mode switch hotkeys'),
         {164}  ('Idle mode hotkey                =  '),
         {165}  ('Manual mode hotkey              =  '),
         {166}  ('Add mode hotkey                 =  '),
         {167}  ('Search mode hotkey              =  '),
         {168}  ('Environment switch hotkey       =  '),
         {169}  ('V-Indication switch hotkey      =  '),
         {170}  ('User options'),
         {171}  ('Initial search flags      =  '),
         {172}  ('User environment options  =  '),
         {173}  ('Color video attribute     =  '),
         {174}  ('Mono video attribute      =  '),
         {175}  ('Search metasymbols'),
         {176}  ('Forward searching                   =  '),
         {177}  ('Backward searching                  =  '),
         {178}  ('NonSpecial symbol follows           =  '),
         {179}  ('Abbreviations dictionary searching  =  '),
         {180}  ('Expressions dictionary searching    =  '),
         {181}  ('Direction order searching           =  '),
         {182}  ('Dictionary order searching          =  '),
         {183}  ('Case-sensitive searching            =  '),
         {184}  ('Dictionary'),
         {185}  ('Name     =  '),
         {186}  ('Comment  =  '),
         {187}  ('Character Case Map Table'),
         {188}  ('Characters'),
         {189}  ('Dump FA-table.'),
         {190}  ('Dump BA-table.'),
         {191}  ('Dump FE-table.'),
         {192}  ('Dump BE-table.'),
         {193}  ('Dump AS-table.'),
         {194}  ('Dump ES-table.'),
         {195}  ('Table address  =  '),
         {196}  ('Forward abbreviation searching table'),
         {197}  ('Backward abbreviation searching table'),
         {198}  ('Forward expression searching table'),
         {199}  ('Backward expression searching table'),
         {200}  ('Abbreviation sizes searching table'),
         {201}  ('Expression sizes searching table'),
         {202}  ('Dump collected statistics for current environment.'),
         {203}  ('Collected statistics for current environment'),
         {204}  ('Dump dictionary name.'),
         {205}  ('Collected statistics (absent nodes not accessed)'),
         {206}  ('Build memory copy of dictionary.'),
         {207}  ('Build environment description.'),
         {208}  ('Copy current keyboard/search mode settings.'),
         {209}  ('Build head-link tables in memory.'),
         {210}  ('Build dictionary table in memory.'),
         {211}  ('Remove dictionary from memory by index'),
         {212}  ('No dictionary found for specified handle.'),
         {213}  ('Dictionary not in separate memory block. Skipped it.'),
         {214}  ('Dictionary found in low memory.'),
         {215}  ('Dictionary  found in high memory.'),
         {216}  ('Cannot free memory for dictionary. Maybe DOS memory chain destroyed.'),
         {217}  ('Warning!! No current dictionary, please set it again.'),
         {218}  ('Dictionary '),
         {219}  ('Unable to remove dictionary from memory.'),
         {220}  ('Mismatch name specified for dictionary in memory.'),
         {221}  ('Matching dictionary found in memory.'),
         {222}  ('List all the loaded dictionaries, * = current.'),
         {223}  ('IDX='),
         {224}  ('name='),
         {225}  ('comment='),
         {226}  ('No loaded dictionaries.'),
         {227}  ('Total of loaded dictionaries = '),
         {228}  ('Remove all the loaded dictionaries from memory.'),
         {229}  ('Select test mode for diagnostics.'),
         {230}  ('Current keyboard handler state: '),
         {231}  ('Select filter for raw user input (1=filter,0=no filter): '),
         {232}  ('Bad boolean value found.'),
         {233}  ('Any string = TSR mode, <CR> = test mode: '),
         {234}  ('Cannot free program environment. Maybe DOS memory chain destroyed.'),
         {235}  ('Installation of TSR version for evaluation.'),
         {236}  ('User input pattern: '),
         {237}  ('Replace string: '),
         {238}  ('Replace string size: '),
         {239}  ('Switch to manual mode.'),
         {240}  ('Environment link table at address = '),
         {241}  ('Enter any string to test: '),
         {242}  ('Switch to idle mode.'),
         {243}  ('User input was: '),
         {244}  ('Raw  input was: '),
         {245}  ('Search input string size: '),
         {246}  ('Replaces before counter: '),
         {247}  ('Search input flags found: '),
         {248}  ('Search input done: '),
         {249}  ('Setup internal variables and do some housekeeping.'),
         {250}  ('Check size of internal resident part.'),
         {251}  ('Bad free space size found. Please re-compile program.'),
         {252}  ('Specified multiplex channel already in use.'),
         {253}  ('Max UMB size = '),
         {254}  (' bytes'),
         {255}  ('Default config path = '),
         {256}  ('No free multiplex channel available. Remove something from memory.'),
         {257}  ('Use resident part for interaction.'),
         {258}  ('Cannot load program. Resident part found.'),
         {259}  ('No specified user dictionary in memory.'),
         {260}  ('Set dictionary '),
         {261}  ('The dictionary with such name already loaded.'),
         {262}  ('Fill with zeroes high memory block.'),
         {263}  ('Cannot to resize high memory block.'),
         {264}  ('Cannot install in high memory. Maybe DOS memory chain destroyed.'),
         {265}  ('Fill with zeroes low memory block.'),
         {266}  (' successfully loaded in high memory.'),
         {267}  (' successfully loaded in low memory.'),
         {268}  ('No other program using our interrupt vectors.'),
         {269}  ('Free the DOS memory blocks for a program code.'),
         {270}  ('Memory block found in low memory.'),
         {271}  ('Memory block found in high memory.'),
         {272}  ('Cannot free program memory. Maybe DOS memory chain destroyed.'),
         {273}  ('Program successfully removed from memory.'),
         {274}  ('Unable to unload program. Interrupt vectors in use by other programs.'),
         {275}  ('Cannot unload program. No resident part found.'),
         {276}  ('Setup new interrupt vectors.'),
         {277}  ('Loading program in high memory.'),
         {278}  ('High memory allocated at '),
         {279}  (', size='),
         {280}  ('Copy code into high memory.'),
         {281}  ('Unable to allocate high memory. Use low memory.'),
         {282}  ('Loading program in low memory.'),
         {283}  ('Install previous interrupt handlers.'),
         {284}  ('Setup new interrupt handlers.'),
         {285}  ('Check installation of interrupt vectors.'),
         {286}  ('Successful installation of interrupt vectors.'),
         {287}  ('Installation of program code in high memory.'),
         {288}  ('Installation of program code in low memory.'),
         {289}  ('Installation of interrupt vectors failed.'),
         {290}  ('Bad installation of interrupts logic. Remove something from memory.'),
         {291}  ('Get free memory space information.'),
         {292}  ('Allocate free space.'),
         {293}  ('idle mode'),
         {294}  ('manual mode'),
         {295}  ('add mode'),
         {296}  ('search mode'),
         {297}  ('Current environment not found.'),
         {298}  ('Other symbols'),
         {299}  ('Auto added character              =  '),
         {300}  ('      (search forward)'),
         {301}  ('      (search backward)'),
         {302}  ('      (search abbreviation)'),
         {303}  ('      (search expression)'),
         {304}  ('      (search first forward)'),
         {305}  ('      (search first abbreviation)'),
         {306}  ('      (search case-sensitive)'),
         {307}  ('      (search middle)'),
         {308}  ('      (search single word)'),
         {309}  ('Character To Scan Code Map Table'),
         {310}  ('Character InWord Map Table'),
         {311}  ('Delimit characters                =  '),
         {312}  ('      (auto add character)'),
         {313}  ('      (video indication mode)'),
         {314}  ('      (static tables compression)'),
         {315}  ('      (static nodes compression)'),
         {316}  ('      (click on mode change)'),
         {317}  ('      (filter raw input)'),
         {318}  ('      (add padding zero for nodes)'),
         {318}  ('      (recognize metasymbols)'),
         {320}  ('      (auto put scan code)'),
         {321}  ('      (use patch method for Microsoft Word)'),
         {322}  ('      (use Int$15/Fn$4F to get hotkey scan code)'),
         {323}  ('Environment/dictionary size'),
         {324}  ('Static environment  =  '),
         {325}  ('FA head link table  =  '),
         {326}  ('BA head link table  =  '),
         {327}  ('FE head link table  =  '),
         {328}  ('BE head link table  =  '),
         {329}  ('AS head link table  =  '),
         {330}  ('ES head link table  =  '),
         {331}  ('Total found size    =  '),
         {332}  ('Output report complete.'),
         {333}  ('Data misalignment. Please re-compile.'),
         {334}  ('Set new timer flag call failed.'),
         {335}  ('Get timer state call failed.'),
         {336}  ('Run timer for estimate processing (1=on,0=off): '),
         {337}  ('Estimate timer is off.'),
         {338}  ('Estimate timer is on, counts in [ms] = '),
         {339}  ('*** Internal information about this executable program ***'),
         {340}  ('YES'),
         {341}  ('NO'),
         {342}  ('Commercial version        =  '),
         {343}  ('Evaluation version        =  '),
         {344}  ('English language          =  '),
         {345}  ('Russian language          =  '),
         {346}  ('Debug extensions          =  '),
         {347}  ('Add space  8 Kbytes       =  '),
         {348}  ('Add space 16 Kbytes       =  '),
         {349}  ('Useful information about resident program and dictionaries.'),
         {350}  ('Not implemented yet.'),
         {351}  ('Get program info call failed.'),
         {352}  ('External release number   =  '),
         {353}  ('External version number   =  '),
         {354}  ('External revision number  =  '),
         {355}  ('Internal release number   =  '),
         {356}  ('Internal version number   =  '),
         {357}  ('Internal revision number  =  '),
         {358}  ('Program segment  =  '),
         {359}  ('Program size     =  '),
         {360}  ('Program interface interrupt vector       =  '),
         {361}  ('Program multiplex channel number         =  '),
         {362}  ('Number of supported functions (0-based)  =  '),
         {363}  ('Current state mode            =  '),
         {364}  ('Current search substate mode  =  '),
         {365}  ('Last status code              =  '),
         {366}  ('Initial wait ticks of timer interrupt  =  '),
         {367}  ('Estimate timer flag        =  '),
         {368}  ('Last estimate timer value  =  '),
         {369}  ('Free space size  =  '),
         {370}  ('Free space link  =  '),
         {371}  ('Warning! Unexpected zero length of buffer.'),
         {372}  ('*** Program information ***'),
         {373}  ('analyze mode'),
         {374}  ('search mode'),
         {375}  ('replace submode'),
         {376}  ('no errors'),
         {377}  ('bad nonspecial symbol'),
         {378}  ('no matching entry at search'),
         {379}  ('empty expression'),
         {380}  ('unknown code'),
         {381}  ('on'),
         {382}  ('off'),
         {383}  ('*** Environment/dictionary information ***'),
         {384}  ('Index   Pointer    Status        Name        Block  Total,Free (size)'),
         {385}  ('free'),
         {386}  ('used'),
         {387}  ('Environment handles statistics:'),
         {388}  ('total = '),
         {389}  ('used = '),
         {390}  ('free = '),
         {391}  ('current = '),
         {392}  ('Current environment settings table at address = '),
         {393}  ('code'),
         {394}  ('low '),
         {395}  ('high'),
         {396}  ('none'),
         {397}  ('Copy free space pointer call failed.'),
         {398}  ('Free space for this dictionary'),
         {399}  ('Free space pointer   =  '),
         {400}  ('Free space size      =  '),
         {401}  ('      (use patch method for old Norton Editor)'),
         {402}  ('Reserve memory size = '),
         {403}  ('Delim definition character        =  '),
         {404}  ('Non-special definition character  =  '),
         {405}  ('All dictionary searching            =  '),
         {406}  ('Single-word searching               =  '),
         {407}  ('Add new dictionary entry call failed.'),
         {408}  ('Multiplex return code =  '),
         {409}  ('bad user definition for new entry'),
         {410}  ('no enough free memory'),
         {411}  ('dictionary in compressed format'),
         {412}  ('bad call'),
         {413}  ('successfully done'),
         {414}  ('no free memory'),
         {415}  ('bad range for environment index'),
         {416}  ('empty environment for this index'),
         {417}  ('this function not implemented yet'),
         {418}  ('bad keyboard mode'),
         {419}  ('invalid parameters for free space link'),
         {420}  ('bad filter flag value'),
         {421}  ('bad interrupt vector number'),
         {422}  ('bad search string or parameters'),
         {423}  ('bad user options subfunction number'),
         {424}  ('bad estimate timer subfunction number'),
         {425}  ('bad user definition string format'),
         {426}  ('user dictionary was compressed'),
         {427}  ('No upper (high) memory. Use low memory.'),
         {428}  ('Open numeric parameter character  =  '),
         {429}  ('Close numeric parameter character =  '),
         {430}  ('bad numeric parameter'),
         {431}  ('Setup estimate timer.'),
         {432}  ('Estimate timer is on.'),
         {433}  ('Bad value to run estimate timer found.'),
         {434}  ('Invalid dictionary search type in line'),
         {435}  ('Invalid boolean parameter state in line'),
         {436}  ('Serial user number        =  '),
         {437}  ('NOT PRESENT'),
         {438}  ('Too large dictionary, no more free heap memory.'),
         {439}  ('Too many words in dictionary, remove something.'),
         {440}  ('Entries/dictionary (max)  =  '),
         {441}  ('Dynamic extension (max)   =  '),
         {442}  ('Dictionary/session (max)  =  '),
         {443}  ('Break input symbol                  =  '),
         {444}  ('Get current environment user options call failed.'),
         {445}  ('Test extensions           =  '),
         {446}  ('Bad range for boolean parameter found in string'),
         {447}  ('!$DebVIDEO!'),
         {448}  ('!$DebDOSCTL!'),
         {449}  ('!$DebCALLBACK!'),
         {450}  ('!$DebCONFIG!'),
         {451}  ('!$DebTYPIST!'),
         {452}  ('Display help file for user.'),
         {453}  ('Demo extensions           =  '),
         {454}  ('*** Short user help screen ***'),
         {455}  ('Purpose:  Intellectual typist for everybody.'),
         {456}  ('Usage:    '),
         {457}  (' [options]  , where'),
         {458}  ('   Decimals and hexadecimals (preceded by '''),
         {459}  (''') are recognized as numbers.'),
         {460}  ('   Switch and parameter may be separated by either '''),
         {461}  (''' or '''),
         {462}  ('   Options may be preceded by either '''),
         {463}  ('   Valid options (all the case-sensitive) are as follows:'),
         {464}  ('      switch     |             meaning              |   default'),
         {465}  ('    Short example:   '),
         {466}  ('| number of screen lines to list   | '),
         {467}  ('=no paging'),
         {468}  ('| environment/dictionary filename  | empty (=none)'),
         {469}  ('| display more debug information   | level 0 (=none)'),
         {470}  ('| load program code into memory    | - (='),
         {471}  ('| load program/data into upper mem.| - (='),
         {472}  ('| unload code and data from memory | - (='),
         {473}  ('| load dictionary into memory      | - (='),
         {474}  ('| set this dictionary as current   | empty (=none)'),
         {475}  ('| remove dictionary from memory    | empty (=none)'),
         {476}  ('| list all loaded dictionaries     | - (='),
         {477}  ('| reserve memory to extend         | '),
         {478}  ('| human language for messages      | 0 (=English)'),
         {479}  ('| interface interrupt number       | '),
         {480}  ('| program multiplex channel        | '),
         {481}  ('| run estimate timer               | '),
         {482}  ('| display info about this version  | - (='),
         {483}  ('| display info about resident part | - (='),
         {484}  ('| display helpfile for user        | - (='),
         {485}  ('| dump text of user dictionary     | - (='),
         {486}  ('| dump current env./dict. from mem.| - (='),
         {487}  ('| dump statistics for current dict.| - (='),
         {488}  ('| run in test mode to evaluate     | - (='),
         {489}  ('| run in demo mode to evaluate     | - (='),
         {490}  ('| division factor for pause        | '),
         {491}  ('| pause delay in seconds           | '),
         {492}  ('| timer ticks before write char    | '),
         {493}  ('| this short help screen           | none'),
         {494}  ('max='),
         {495}  (', max='),
         {496}  ('min='),
         {497}  ('[num]'),
         {498}  ('[level]'),
         {499}  ('[str]'),
         {500}  ('bad statistics block subfunction number'),
         {501}  ('bad statistics block pointer'),
         {502}  ('Call to get statistics block failed.'),
         {503}  ('Call to set statistics block failed.'),
         {504}  ('Current statistics block at address = '),
         {505}  ('New statistics block at address = '),
         {506}  ('Statistics extensions     =  '),
         {507}  ('| output statistics of typing      | - (='),
         {508}  ('| reset statistics of typing       | - (='),
         {509}  ('| set time statistics (minutes)    | '),
         {510}  ('Typing statistics (max)   =  '),
         {511}  (' minutes'),
         {512}  ('Setup typing monitoring watch.'),
         {513}  ('Statblock successfully loaded in high memory.'),
         {514}  ('Statblock successfully loaded in low memory.'),
         {515}  ('No support of typing statistics for this version.'),
         {516}  ('Remove typing monitoring watch.'),
         {517}  ('Statblock found in low memory.'),
         {518}  ('Statblock found in high memory.'),
         {519}  ('Cannot free memory for statblock. Maybe DOS memory chain destroyed.'),
         {520}  ('No allocated memory in statblock.'),
         {521}  ('Reset all variables in the current statblock.'),
         {522}  ('New memory for statblock at address = '),
         {523}  ('Size for typing watch memory = '),
         {524}  ('Memory in use for statblock at address = '),
         {525}  ('Disable typing monitoring watch.'),
         {526}  ('Remove allocated memory for statblock.'),
         {527}  ('Empty memory block pointer in statblock found.'),
         {528}  ('Typing watch monitoring state         =  '),
         {529}  ('Memory pool for statblock at address  =  '),
         {530}  ('Typing statistics block at address    =  '),
         {531}  ('*** Typing statistics information ***'),
         {532}  ('Output typing watch monitoring statistics.'),
         {533}  ('Typing watch monitoring statistics'),
         {534}  ('Current pointer in memory pool        =  '),
         {535}  ('Initial timer ticks value             =  '),
         {536}  ('Current timer ticks value             =  '),
         {537}  ('Starting hour (from system)           =  '),
         {538}  ('Starting minute (from system)         =  '),
         {539}  ('Total minutes to watch typing         =  '),
         {540}  ('Remaining minutes to watch typing     =  '),
         {541}  ('Typing monitoring statistics for each minute'),
         {542}  ('diagnostic info'),
         {543}  ('No information now.'),
         {544}  ('**Time**     **Keystrokes statistics**'),
         {545}  ('-HH:MM-   -Total*-  -*User*-  -Typist-  -Ratio-'),
         {546}  ('--Total results statistics--'),
         {547}  ('--More fair statistics for TYPIST--'),
         {548}  ('-----  ----------  ------  ----------------  -----  -----------------'),
         {549}  ('duplicate entry'),
         {550}  ('same entry'),
         {551}  ('Active state border color =  '),
         {552}  ('Idle state border color   =  '),
         {553}  ('      (use border screen color as state indicator)'),
         {554}  ('      (empty abbreviation enabled)'),
         {555}  ('empty abbreviation here'),
         {556}  ('Memory pool size for statblock        =  '),
         {557}  ('Typing monitoring statistics already in progress.'),
         {558}  ('*** Total used memory information ***'),
         {559}  ('Total memory used by code & data = '),
         {560}  ('Max CMB size = '),
         {561}  ('Estimated dictionary size in memory = '),
         {562}  (' successfully removed from memory.'),
         {563}  (' as current active dictionary.'),
         {564}  ('| DOS environment config. variable | '),
         {565}  ('| journal output filename          | empty (=none)'),
         {566}  ('Option <'+Globals.asUseInt154F+'> is not supported on this computer'),
         {567}  ('      (use Int$16/Fn$01,$11 to filter input stream)'),
         {568}  ('Error at parsing of user DOS environment variable.'),
         {569}  ('Current DOS environment variable = ')
{$ELSE}
         {019}  (asBlank),
         {020}  (asBlank),
         {021}  (asBlank),
         {022}  (asBlank),
         {023}  (asBlank),
         {024}  (asBlank),
         {025}  (asBlank),
         {026}  (asBlank),
         {027}  (asBlank),
         {028}  (asBlank),
         {029}  (asBlank),
         {030}  (asBlank),
         {031}  (asBlank),
         {032}  (asBlank),
         {033}  (asBlank),
         {034}  (asBlank),
         {035}  (asBlank),
         {036}  (asBlank),
         {037}  (asBlank),
         {038}  (asBlank),
         {039}  (asBlank),
         {040}  (asBlank),
         {041}  (asBlank),
         {042}  (asBlank),
         {043}  (asBlank),
         {044}  (asBlank),
         {045}  (asBlank),
         {046}  (asBlank),
         {047}  (asBlank),
         {048}  (asBlank),
         {049}  (asBlank),
         {050}  (asBlank),
         {051}  (asBlank),
         {052}  (asBlank),
         {053}  (asBlank),
         {054}  (asBlank),
         {055}  (asBlank),
         {056}  (asBlank),
         {057}  (asBlank),
         {058}  (asBlank),
         {059}  (asBlank),
         {060}  (asBlank),
         {061}  (asBlank),
         {062}  (asBlank),
         {063}  (asBlank),
         {064}  (asBlank),
         {065}  (asBlank),
         {066}  (asBlank),
         {067}  (asBlank),
         {068}  (asBlank),
         {069}  (asBlank),
         {070}  (asBlank),
         {071}  (asBlank),
         {072}  (asBlank),
         {073}  (asBlank),
         {074}  (asBlank),
         {075}  (asBlank),
         {076}  (asBlank),
         {077}  (asBlank),
         {078}  (asBlank),
         {079}  (asBlank),
         {080}  (asBlank),
         {081}  (asBlank),
         {082}  (asBlank),
         {083}  (asBlank),
         {084}  (asBlank),
         {085}  (asBlank),
         {086}  (asBlank),
         {087}  (asBlank),
         {088}  (asBlank),
         {089}  (asBlank),
         {090}  (asBlank),
         {091}  (asBlank),
         {092}  (asBlank),
         {093}  (asBlank),
         {094}  (asBlank),
         {095}  (asBlank),
         {096}  (asBlank),
         {097}  (asBlank),
         {098}  (asBlank),
         {099}  (asBlank),
         {100}  (asBlank),
         {101}  (asBlank),
         {102}  (asBlank),
         {103}  (asBlank),
         {104}  (asBlank),
         {105}  (asBlank),
         {106}  (asBlank),
         {107}  (asBlank),
         {108}  (asBlank),
         {109}  (asBlank),
         {110}  (asBlank),
         {111}  (asBlank),
         {112}  (asBlank),
         {113}  (asBlank),
         {114}  (asBlank),
         {115}  (asBlank),
         {116}  (asBlank),
         {117}  (asBlank),
         {118}  (asBlank),
         {119}  (asBlank),
         {120}  (asBlank),
         {121}  (asBlank),
         {122}  (asBlank),
         {123}  (asBlank),
         {124}  (asBlank),
         {125}  (asBlank),
         {126}  (asBlank),
         {127}  (asBlank),
         {128}  (asBlank),
         {129}  (asBlank),
         {130}  (asBlank),
         {131}  (asBlank),
         {132}  (asBlank),
         {133}  (asBlank),
         {134}  (asBlank),
         {135}  (asBlank),
         {136}  (asBlank),
         {137}  (asBlank),
         {138}  (asBlank),
         {139}  (asBlank),
         {140}  (asBlank),
         {141}  (asBlank),
         {142}  (asBlank),
         {143}  (asBlank),
         {144}  (asBlank),
         {145}  (asBlank),
         {146}  (asBlank),
         {147}  (asBlank),
         {148}  (asBlank),
         {149}  (asBlank),
         {150}  (asBlank),
         {151}  (asBlank),
         {152}  (asBlank),
         {153}  (asBlank),
         {154}  (asBlank),
         {155}  (asBlank),
         {156}  (asBlank),
         {157}  (asBlank),
         {158}  (asBlank),
         {159}  (asBlank),
         {160}  (asBlank),
         {161}  (asBlank),
         {162}  (asBlank),
         {163}  (asBlank),
         {164}  (asBlank),
         {165}  (asBlank),
         {166}  (asBlank),
         {167}  (asBlank),
         {168}  (asBlank),
         {169}  (asBlank),
         {170}  (asBlank),
         {171}  (asBlank),
         {172}  (asBlank),
         {173}  (asBlank),
         {174}  (asBlank),
         {175}  (asBlank),
         {176}  (asBlank),
         {177}  (asBlank),
         {178}  (asBlank),
         {179}  (asBlank),
         {180}  (asBlank),
         {181}  (asBlank),
         {182}  (asBlank),
         {183}  (asBlank),
         {184}  (asBlank),
         {185}  (asBlank),
         {186}  (asBlank),
         {187}  (asBlank),
         {188}  (asBlank),
         {189}  (asBlank),
         {190}  (asBlank),
         {191}  (asBlank),
         {192}  (asBlank),
         {193}  (asBlank),
         {194}  (asBlank),
         {195}  (asBlank),
         {196}  (asBlank),
         {197}  (asBlank),
         {198}  (asBlank),
         {199}  (asBlank),
         {200}  (asBlank),
         {201}  (asBlank),
         {202}  (asBlank),
         {203}  (asBlank),
         {204}  (asBlank),
         {205}  (asBlank),
         {206}  (asBlank),
         {207}  (asBlank),
         {208}  (asBlank),
         {209}  (asBlank),
         {210}  (asBlank),
         {211}  (asBlank),
         {222}  (asBlank),
         {213}  (asBlank),
         {214}  (asBlank),
         {215}  (asBlank),
         {216}  (asBlank),
         {217}  (asBlank),
         {218}  (asBlank),
         {219}  (asBlank),
         {220}  (asBlank),
         {221}  (asBlank),
         {222}  (asBlank),
         {223}  (asBlank),
         {224}  (asBlank),
         {225}  (asBlank),
         {226}  (asBlank),
         {227}  (asBlank),
         {228}  (asBlank),
         {229}  (asBlank),
         {230}  (asBlank),
         {231}  (asBlank),
         {232}  (asBlank),
         {233}  (asBlank),
         {234}  (asBlank),
         {235}  (asBlank),
         {236}  (asBlank),
         {237}  (asBlank),
         {238}  (asBlank),
         {239}  (asBlank),
         {240}  (asBlank),
         {241}  (asBlank),
         {242}  (asBlank),
         {243}  (asBlank),
         {244}  (asBlank),
         {245}  (asBlank),
         {246}  (asBlank),
         {247}  (asBlank),
         {248}  (asBlank),
         {249}  (asBlank),
         {250}  (asBlank),
         {251}  (asBlank),
         {252}  (asBlank),
         {253}  (asBlank),
         {254}  (asBlank),
         {255}  (asBlank),
         {256}  (asBlank),
         {257}  (asBlank),
         {258}  (asBlank),
         {259}  (asBlank),
         {260}  (asBlank),
         {261}  (asBlank),
         {262}  (asBlank),
         {263}  (asBlank),
         {264}  (asBlank),
         {265}  (asBlank),
         {266}  (asBlank),
         {267}  (asBlank),
         {268}  (asBlank),
         {269}  (asBlank),
         {270}  (asBlank),
         {271}  (asBlank),
         {272}  (asBlank),
         {273}  (asBlank),
         {274}  (asBlank),
         {275}  (asBlank),
         {276}  (asBlank),
         {277}  (asBlank),
         {278}  (asBlank),
         {279}  (asBlank),
         {280}  (asBlank),
         {281}  (asBlank),
         {282}  (asBlank),
         {283}  (asBlank),
         {284}  (asBlank),
         {285}  (asBlank),
         {286}  (asBlank),
         {287}  (asBlank),
         {288}  (asBlank),
         {289}  (asBlank),
         {290}  (asBlank),
         {291}  (asBlank),
         {292}  (asBlank),
         {293}  (asBlank),
         {294}  (asBlank),
         {295}  (asBlank),
         {296}  (asBlank),
         {297}  (asBlank),
         {298}  (asBlank),
         {299}  (asBlank),
         {300}  (asBlank),
         {301}  (asBlank),
         {302}  (asBlank),
         {303}  (asBlank),
         {304}  (asBlank),
         {305}  (asBlank),
         {306}  (asBlank),
         {307}  (asBlank),
         {308}  (asBlank),
         {309}  (asBlank),
         {310}  (asBlank),
         {311}  (asBlank),
         {312}  (asBlank),
         {313}  (asBlank),
         {314}  (asBlank),
         {315}  (asBlank),
         {316}  (asBlank),
         {317}  (asBlank),
         {318}  (asBlank),
         {319}  (asBlank),
         {320}  (asBlank),
         {321}  (asBlank),
         {322}  (asBlank),
         {323}  (asBlank),
         {324}  (asBlank),
         {325}  (asBlank),
         {326}  (asBlank),
         {327}  (asBlank),
         {328}  (asBlank),
         {329}  (asBlank),
         {330}  (asBlank),
         {331}  (asBlank),
         {332}  (asBlank),
         {333}  (asBlank),
         {334}  (asBlank),
         {335}  (asBlank),
         {336}  (asBlank),
         {337}  (asBlank),
         {338}  (asBlank),
         {339}  (asBlank),
         {340}  (asBlank),
         {341}  (asBlank),
         {342}  (asBlank),
         {343}  (asBlank),
         {344}  (asBlank),
         {345}  (asBlank),
         {346}  (asBlank),
         {347}  (asBlank),
         {348}  (asBlank),
         {349}  (asBlank),
         {350}  (asBlank),
         {351}  (asBlank),
         {352}  (asBlank),
         {353}  (asBlank),
         {354}  (asBlank),
         {355}  (asBlank),
         {356}  (asBlank),
         {357}  (asBlank),
         {358}  (asBlank),
         {359}  (asBlank),
         {360}  (asBlank),
         {361}  (asBlank),
         {362}  (asBlank),
         {363}  (asBlank),
         {364}  (asBlank),
         {365}  (asBlank),
         {366}  (asBlank),
         {367}  (asBlank),
         {368}  (asBlank),
         {369}  (asBlank),
         {370}  (asBlank),
         {371}  (asBlank),
         {372}  (asBlank),
         {373}  (asBlank),
         {374}  (asBlank),
         {375}  (asBlank),
         {376}  (asBlank),
         {377}  (asBlank),
         {378}  (asBlank),
         {379}  (asBlank),
         {380}  (asBlank),
         {381}  (asBlank),
         {382}  (asBlank),
         {383}  (asBlank),
         {384}  (asBlank),
         {385}  (asBlank),
         {386}  (asBlank),
         {387}  (asBlank),
         {388}  (asBlank),
         {389}  (asBlank),
         {390}  (asBlank),
         {391}  (asBlank),
         {392}  (asBlank),
         {393}  (asBlank),
         {394}  (asBlank),
         {395}  (asBlank),
         {396}  (asBlank),
         {397}  (asBlank),
         {398}  (asBlank),
         {399}  (asBlank),
         {400}  (asBlank),
         {401}  (asBlank),
         {402}  (asBlank),
         {403}  (asBlank),
         {404}  (asBlank),
         {405}  (asBlank),
         {406}  (asBlank),
         {407}  (asBlank),
         {408}  (asBlank),
         {409}  (asBlank),
         {410}  (asBlank),
         {411}  (asBlank),
         {412}  (asBlank),
         {413}  (asBlank),
         {414}  (asBlank),
         {415}  (asBlank),
         {416}  (asBlank),
         {417}  (asBlank),
         {418}  (asBlank),
         {419}  (asBlank),
         {420}  (asBlank),
         {421}  (asBlank),
         {422}  (asBlank),
         {423}  (asBlank),
         {424}  (asBlank),
         {425}  (asBlank),
         {426}  (asBlank),
         {427}  (asBlank),
         {428}  (asBlank),
         {429}  (asBlank),
         {430}  (asBlank),
         {431}  (asBlank),
         {432}  (asBlank),
         {433}  (asBlank),
         {434}  (asBlank),
         {435}  (asBlank),
         {436}  (asBlank),
         {437}  (asBlank),
         {438}  (asBlank),
         {439}  (asBlank),
         {440}  (asBlank),
         {441}  (asBlank),
         {442}  (asBlank),
         {443}  (asBlank),
         {444}  (asBlank),
         {445}  (asBlank),
         {446}  (asBlank),
         {447}  (asBlank),
         {448}  (asBlank),
         {449}  (asBlank),
         {450}  (asBlank),
         {451}  (asBlank),
         {452}  (asBlank),
         {453}  (asBlank),
         {454}  (asBlank),
         {455}  (asBlank),
         {456}  (asBlank),
         {457}  (asBlank),
         {458}  (asBlank),
         {459}  (asBlank),
         {460}  (asBlank),
         {461}  (asBlank),
         {462}  (asBlank),
         {463}  (asBlank),
         {464}  (asBlank),
         {465}  (asBlank),
         {466}  (asBlank),
         {467}  (asBlank),
         {468}  (asBlank),
         {469}  (asBlank),
         {470}  (asBlank),
         {471}  (asBlank),
         {472}  (asBlank),
         {473}  (asBlank),
         {474}  (asBlank),
         {475}  (asBlank),
         {476}  (asBlank),
         {477}  (asBlank),
         {478}  (asBlank),
         {479}  (asBlank),
         {480}  (asBlank),
         {481}  (asBlank),
         {482}  (asBlank),
         {483}  (asBlank),
         {484}  (asBlank),
         {485}  (asBlank),
         {486}  (asBlank),
         {487}  (asBlank),
         {488}  (asBlank),
         {489}  (asBlank),
         {490}  (asBlank),
         {491}  (asBlank),
         {492}  (asBlank),
         {493}  (asBlank),
         {494}  (asBlank),
         {495}  (asBlank),
         {496}  (asBlank),
         {497}  (asBlank),
         {498}  (asBlank),
         {499}  (asBlank),
         {500}  (asBlank),
         {501}  (asBlank),
         {502}  (asBlank),
         {503}  (asBlank),
         {504}  (asBlank),
         {505}  (asBlank),
         {506}  (asBlank),
         {507}  (asBlank),
         {508}  (asBlank),
         {509}  (asBlank),
         {510}  (asBlank),
         {511}  (asBlank),
         {512}  (asBlank),
         {513}  (asBlank),
         {514}  (asBlank),
         {515}  (asBlank),
         {516}  (asBlank),
         {517}  (asBlank),
         {518}  (asBlank),
         {519}  (asBlank),
         {520}  (asBlank),
         {521}  (asBlank),
         {522}  (asBlank),
         {523}  (asBlank),
         {524}  (asBlank),
         {525}  (asBlank),
         {526}  (asBlank),
         {527}  (asBlank),
         {528}  (asBlank),
         {529}  (asBlank),
         {530}  (asBlank),
         {531}  (asBlank),
         {532}  (asBlank),
         {533}  (asBlank),
         {534}  (asBlank),
         {535}  (asBlank),
         {536}  (asBlank),
         {537}  (asBlank),
         {538}  (asBlank),
         {539}  (asBlank),
         {540}  (asBlank),
         {541}  (asBlank),
         {542}  (asBlank),
         {543}  (asBlank),
         {544}  (asBlank),
         {545}  (asBlank),
         {546}  (asBlank),
         {547}  (asBlank),
         {548}  (asBlank),
         {549}  (asBlank),
         {550}  (asBlank),
         {551}  (asBlank),
         {552}  (asBlank),
         {553}  (asBlank),
         {554}  (asBlank),
         {555}  (asBlank),
         {556}  (asBlank),
         {557}  (asBlank),
         {558}  (asBlank),
         {559}  (asBlank),
         {560}  (asBlank),
         {561}  (asBlank),
         {562}  (asBlank),
         {563}  (asBlank),
         {564}  (asBlank),
         {565}  (asBlank),
         {566}  (asBlank),
         {567}  (asBlank),
         {568}  (asBlank),
         {569}  (asBlank)
{$ENDIF} {EngVer}
          ),(
         {001}  ('宩   ᮮ饭  祭.'),
         {002}  (' ⠭ 몮 প.'),
         {003}  ('᪨   ন  ⮩ ॠ樨.'),
         {004}  ('᪨   ন  ⮩ ॠ樨.'),
         {005}  ('室  Intel 80186+.'),
         {006}  ('祣  ᤥ.'),
         {007}  ('襭.'),
         {008}  (' 設⪠'),
         {009}  (' 䠭'),
         {010}  ('᪮ ࠢ ()'),
         {011}  ('設⪠'),
         {012}  (''),
         {013}  ('設⪠: '),
         {014}  ('!室!=>'),
         {015}  ('!⫠!'),
         {016}  ('ᯮ  ⥫쭮 :'),
         {017}  (''),
         {018}  (' <ENTER>  த   -  室:'),
{$IFDEF   RusVer}
         {019}  ('४饭 짮⥫.'),
         {020}  (' 䠩 '),
         {021}  ('   䠩 .'),
         {022}  ('   .'),
         {023}  ('뢮  祭.'),
         {024}  ('࠭ ⥪騥  뢠.'),
         {025}  ('⠭ ⥪騥  뢠.'),
         {026}  (' ⠭ ⥪騥  뢠.'),
         {027}  ('宩 ᪨ ࠬ   ப'),
         {028}  ('宩 ᫮ ࠬ   ப'),
         {029}  ('宩   ᫮ ࠬ   ப'),
         {030}  ('宩 ⮢ ࠬ   ப'),
         {031}  ('宩   ⮢ ࠬ   ப'),
         {032}  ('宩 ப ࠬ   ப'),
         {033}  ('祭  ப  ࠬ   ப'),
         {034}  ('  ४⥫  ப'),
         {035}  ('ন ४⥫   ப'),
         {036}  ('஢ 짮⥫᪮ ᫮.'),
         {037}  ('ॢ'),
         {038}  ('ࠦ'),
         {039}  (''),
         {040}  (' ⨪'),
         {041}  (' ⮩ ᫮.'),
         {042}  ('᫮  ᥩ  ᫮'),
         {043}  (''),
         {044}  (''),
         {045}  ('㬬  ⮩ ⠡'),
         {046}  ('짮⥫᪨ ᫮'),
         {047}  ('⨪  ⭮ FA-⠡'),
         {048}  ('⨪  ⭮ BA-⠡'),
         {049}  ('⨪  ⭮ FE-⠡'),
         {050}  ('⨪  ⭮ BE-⠡'),
         {051}  ('⨪  ⭮ AS-⠡'),
         {052}  ('⨪  ⭮ ES-⠡'),
         {053}  ('宩 ᨬ(-)  砫 䫠 ᪠ 짮⥫.'),
         {054}  ('ୠ ॢ  '),
         {055}  ('। ⨯ ᪠  祢 ᫮  '),
         {056}  ('宩 ᫥ ࠬ  ப'),
         {057}  ('宩 ᨭ⠪  ᫥ ࠬ  ப'),
         {058}  ('宩 ᨭ⠪  ப 짮⥫  ப'),
         {059}  ('⢨⥫쭮 ।饥 । 뢠饩   ப'),
         {060}  ('⢨⥫쭠 ப ᪠-  '),
         {061}  ('⢨⥫쭮 । 뢠饩   ப'),
         {062}  ('⢨⥫ ⨯ 浪 ஢  ப'),
         {063}  (' 䠩 䨣樨'),
         {064}  ('   䠩 䨣樨.'),
         {065}  ('訡 ⥭ 䠩 䨣樨.'),
         {066}  (' ᥪ '),
         {067}  ('⢨⥫쭮 । ᥪ樨  ப'),
         {068}  ('⢨⥫쭮 । ᥪ樨  ப'),
         {069}  ('⢨⥫쭮 祢 ᫮ ࠬ  ப'),
         {070}  (' 짮⥫᪮  <from>  ப'),
         {071}  ('ய饭 祢 ᫮'),
         {072}  (' ப'),
         {073}  ('ய饭 짮⥫᪠ ॢ  ப'),
         {074}  ('ॢ襭  ࠧ⥫  ப'),
         {075}  ('⮥ 짮⥫᪮ ࠦ  ᫮  ப'),
         {076}  ('⢨⥫  ᥪ樨 .'),
         {077}  (' 䨣樨 .'),
         {078}  ('஢  祭'),
         {079}  (' 㯭.'),
         {080}  ('  祭  ᢮.'),
         {081}  ('  祭  .'),
         {082}  (' ᢮  祭.'),
         {083}  ('    ᢮  祭.'),
         {084}  (' ᢮  祭'),
         {085}  (' 㦥 室饩    ணࠬ.'),
         {086}  ('⭮   .'),
         {087}  (' 祭  १⭮ '),
         {088}  (' ⢨⥫  㦥.'),
         {089}  ('㤠祭 맮  祭 ᯨ᪠ 㦥.'),
         {090}  ('ᬮ ᯨ᮪ 㦥  ᢮ .'),
         {091}  ('㤠祭 맮  祭 ⥪饣 ०.'),
         {092}  (' ०'),
         {093}  ('㤠祭 맮  祭 ࠡ⠭  짮⥫.'),
         {094}  ('騩  㦥'),
         {095}  ('㤠祭 맮  祭 ⥪饣  㦥.'),
         {096}  ('㤠祭 맮  祭 ⥪ ⠭  㦥.'),
         {097}  ('㤠祭 맮  祭  짮⥫  ᪠.'),
         {098}  ('娥 ࠬ   ᪠  ᫮.'),
         {099}  ('㤠祭 맮  祭  ⠭.'),
         {100}  ('㤠祭 맮  ⠭  䫠 䨫樨.'),
         {101}  ('㤠祭 맮  ⠭ ண  뢠.'),
         {102}  ('㤠祭 맮  祭 ண  뢠Get old intvec call failed.'),
         {103}  ('㤠祭 맮  ⠭  ०  ୮ .'),
         {104}  ('㤠祭 맮  ࠧ饭  ᢮ ࠭⢠.'),
         {105}  ('筮 ᢮   㫥.'),
         {106}  ('㤠祭 맮  祭 ଠ樨  ᢮ .'),
         {107}  (' '),
         {108}  (' 㫠'),
         {109}  ('ᯮ짮'),
         {110}  ('᮪ 㯭 ᫮३.'),
         {111}  ('᮪ 㦥: 㯭 '),
         {112}  (' 裡'),
         {113}  (' 㦥'),
         {114}  ('⠡ ᠭ'),
         {115}  ('  㦥'),
         {116}  ('  ᯨ 㦥 '),
         {117}  (' 㦥 .  ᯮ㥬 ᫮  .'),
         {118}  ('  ᯨ᪠ 㦥 '),
         {119}  ('  㤠 ᯮ㥬 㦥  ⠡  .'),
         {120}  ('⠭  ⥪騩  㦥'),
         {121}  ('㤠祭 맮  ⠭   㦥.'),
         {122}  ('㤠祭 맮  祭 ⥪饣 ﭨ.'),
         {123}  ('㤠祭 맮   ⥪饣 㦥.'),
         {124}  ('㤠祭 맮   ⥪饣 㪠⥫ ᢮ ࠭⢠.'),
         {125}  ('㤠祭 맮   䥩 祭.'),
         {126}  ('樨 㧫'),
         {127}  ('ࠡ⠭  ᦠ⮩ "ன" ᪮ ⠡ 砫 裡'),
         {128}  (' ⮢ '),
         {129}  (''),
         {130}  (' ⮢'),
         {131}  ('㬬  '),
         {132}  ('ப ॢ 㧫'),
         {133}  ('  '),
         {134}  ('  ⠡'),
         {135}  ('᫮  ⮢ ⨬ 㧫'),
         {136}  ('樨 㧫'),
         {137}  ('騩 '),
         {138}  ('ᦠ'),
         {139}  (' FA-'),
         {140}  (' BA-'),
         {141}  (' FE-'),
         {142}  (' BE-'),
         {143}  (' AS-'),
         {144}  (' ES-'),
         {145}  (' FA-裡  㧫'),
         {146}  (' BA-裡  㧫'),
         {147}  (' FE-裡  㧫'),
         {148}  (' BE-裡  㧫'),
         {149}  (' AS-裡  㧫'),
         {150}  (' ES-裡  㧫'),
         {151}  (' 宦 㧫'),
         {152}  (' ᮢ 㧫'),
         {153}  (' ॢ 㧫'),
         {154}  (' ࠦ 㧫'),
         {155}  ('ப ࠦ 㧫'),
         {156}  ('㬬  室'),
         {157}  ('㬬 ⮢  ⮣ ᫮  ⠡ = '),
         {158}  ('஢ 㦥.'),
         {159}  ('饥 㦥  ᫮६'),
         {160}  ('஢ ᮡ࠭ ⨪   㧫.'),
         {161}  ('஢ 樨/⠭ 㦥.'),
         {162}  ('஢ ᫮.'),
         {163}  ('뢠  ४祭 ०'),
         {164}  (' 맮 ⮣ ०    =  '),
         {165}  (' 맮 筮 ०    =  '),
         {166}  (' 맮 ० ७ =  '),
         {167}  (' 맮 ० ᪠     =  '),
         {168}  (' 맮 ᬥ 㦥   =  '),
         {169}  (' 맮 ᬥ -樨 =  '),
         {170}  ('樨 짮⥫'),
         {171}  ('砫 䫠 ᪠       =  '),
         {172}  ('樨 㦥 짮⥫ =  '),
         {173}  ('⭮  ਡ        =  '),
         {174}  ('஬  ਡ    =  '),
         {175}  ('ᨬ ᪠'),
         {176}  ('  砫                      =  '),
         {177}  ('                         =  '),
         {178}  ('   ᨬ       =  '),
         {179}  ('  ᫮ ॢ         =  '),
         {180}  ('  ᫮ ࠦ           =  '),
         {181}  ('冷 ࠢ ᪠          =  '),
         {182}  ('冷 ᪠  ᫮          =  '),
         {183}  ('  ⢨⥫쭮  ᤢ  =  '),
         {184}  (''),
         {185}  ('          =  '),
         {186}  ('਩  =  '),
         {187}  (' ⮡ࠦ ⢨⥫쭮 '),
         {188}  (''),
         {189}  ('஢ FA-⠡.'),
         {190}  ('஢ BA-⠡.'),
         {191}  ('஢ FE-⠡.'),
         {192}  ('஢ BE-⠡.'),
         {193}  ('஢ AS-⠡.'),
         {194}  ('஢ ES-⠡.'),
         {195}  (' ⠡  =  '),
         {196}  (' ᪠  砫 ॢ'),
         {197}  (' ᪠   ॢ'),
         {198}  (' ᪠  砫 ࠦ'),
         {199}  (' ᪠   ࠦ'),
         {200}  (' ᪠   ॢ'),
         {201}  (' ᪠   ࠦ'),
         {202}  ('஢ ᮡ࠭ ⨪  ⥪饣 㦥.'),
         {203}  ('࠭ ⨪  ⥪饣 㦥'),
         {204}  ('஢  ᫮.'),
         {205}  ('࠭ ⨪ (騥 㧫  室)'),
         {206}  ('ந  ᫮  .'),
         {207}  ('ந ᠭ 㦥.'),
         {208}  ('஢ ⥪騥 ⠭ ० /᪠.'),
         {209}  ('ந ⠡ 砫 痢  .'),
         {210}  ('ந ⠡ ᫮  .'),
         {211}  (' ᫮    '),
         {212}  ('  ᫮  㪠 .'),
         {213}  ('   ⤥쭮  . ய饭.'),
         {214}  ('   筮 .'),
         {215}  ('   孮 .'),
         {216}  ('  ᢮   ᫮.  楯    ࠧ襭.'),
         {217}  ('!!  ⥪饣 ᫮, ⠭  .'),
         {218}  (' '),
         {219}  ('  ﭨ 㤠 ᫮  .'),
         {220}  ('    ᫮  㪠 .'),
         {221}  ('室騩 ᫮   .'),
         {222}  ('᮪  㦥 ᫮३, * = ⥪騩.'),
         {223}  ('='),
         {224}  ('='),
         {225}  ('਩='),
         {226}  (' 㦥 ᫮३.'),
         {227}  ('᫮ 㦥 ᫮३ = '),
         {228}  ('    㦥 ᫮.'),
         {229}  (' ०   ⨪.'),
         {230}  ('饥 ﭨ ࠡ稪 : '),
         {231}  ('⠭ 䨫  ࠡ⠭  (1=,0=): '),
         {232}  (' ᪠ 稭 .'),
         {233}  (' ப = TSR ०, <> = ⮢ ०: '),
         {234}  ('  ᢮ 㦥 ணࠬ.  楯    ࠧ襭.'),
         {235}  ('⠭ TSR-ᨨ  業.'),
         {236}  ('ࠧ  짮⥫: '),
         {237}  ('ப ⠭: '),
         {238}  (' ப ⠭: '),
         {239}  ('३  筮 ०.'),
         {240}  (' 裡 㦥   = '),
         {241}  ('  ப  : '),
         {242}  ('३  ⮩ ०.'),
         {243}  ('짮⥫᪨ : '),
         {244}  ('ࠡ⠭ : '),
         {245}  (' ப   ᪠: '),
         {246}  (' ० : '),
         {247}  ('   ᪠: '),
         {248}  (' ᪠ ࠡ⠭: '),
         {249}  ('⠭ ७ ६  .'),
         {250}  ('஢ ࠧ ७ १⭮ .'),
         {251}  ('宩 ࠧ ᢮ ࠭⢠. ४ ணࠬ.'),
         {252}  ('  祭 㦥 .'),
         {253}  (' 襣 UMB = '),
         {254}  (' '),
         {255}  ('  䨣樨  ᮣ襭 = '),
         {256}  (' 㯭 ᢮  祭.  -  .'),
         {257}  ('ᯮ짮 १   ⢨.'),
         {258}  ('  㧨 ணࠬ. ⭠  㦥 .'),
         {259}  (' 㪠 짮⥫ ᫮  .'),
         {260}  ('⠭ ᫮ '),
         {261}  ('  ⠪  㦥 㦥.'),
         {262}  (' ﬨ 孨  .'),
         {263}  ('訡   ࠧ 孥  .'),
         {264}  ('  㧨   .  楯    ࠧ襭.'),
         {265}  (' ﬨ   .'),
         {266}  (' ᯥ譮 㦥   .'),
         {267}  (' ᯥ譮 㦥   .'),
         {268}  ('  ᯮ   뢠.'),
         {269}  ('᢮      ணࠬ.'),
         {270}  ('    筮 .'),
         {271}  ('    孥 .'),
         {272}  ('  ᢮   ணࠬ.  楯    ࠧ襭.'),
         {273}  ('ணࠬ ᯥ譮 㤠  .'),
         {274}  ('  㧨 ணࠬ.  뢠 ᯮ 㣨 ணࠬ.'),
         {275}  ('  㧨 ணࠬ. ⭠   .'),
         {276}  ('⠭   뢭.'),
         {277}  ('㧪 ணࠬ   .'),
         {278}  ('  뤥= '),
         {279}  (', ='),
         {280}  ('஢    .'),
         {281}  ('  ।  . ᯮ짮  .'),
         {282}  ('㧪 ணࠬ   .'),
         {283}  (' ० ࠡ稪 뢠.'),
         {284}  ('⠭  ࠡ稪 뢠.'),
         {285}  ('஢ ⠭ ஢ 뢠.'),
         {286}  ('ᯥ譠 ⠭ ஢ 뢠.'),
         {287}  ('饭 ணࠬ   孥 .'),
         {288}  ('饭 ணࠬ   筮 .'),
         {289}  ('㤠  ࠧ饭 ஢ 뢠.'),
         {290}  ('   ࠧ饭 뢠.  -  .'),
         {291}  (' ଠ  ᢮  ࠭⢠.'),
         {292}  ('। ᢮ ࠭⢮.'),
         {293}  ('⮩ ०'),
         {294}  ('筮 ०'),
         {295}  ('० ७'),
         {296}  ('० ᪠'),
         {297}  ('饥 㦥  .'),
         {298}  ('㣨 ᨬ'),
         {299}  ('⮬᪨ 塞   =  '),
         {300}  ('      (  砫)'),
         {301}  ('      (  )'),
         {302}  ('      ( ॢ)'),
         {303}  ('      ( ࠦ)'),
         {304}  ('      (   砫)'),
         {305}  ('      (  ॢ)'),
         {306}  ('      (  ⢨⥫쭮  ᤢ)'),
         {307}  ('      (  )'),
         {308}  ('      ( ⮫쪮 ᫮)'),
         {309}  (' ⮡ࠦ   ᪠-'),
         {310}  (' ⮡ࠦ 宦   ᫮'),
         {311}  (' ࠧ                 =  '),
         {312}  ('      (⮬᪨ 塞 )'),
         {313}  ('      (० -樨)'),
         {314}  ('      (ᦠ⨥ ᪨ ⠡)'),
         {315}  ('      (ᦠ⨥ ᪨ 㧫)'),
         {316}  ('      (砭  ᬥ ०)'),
         {317}  ('      (䨫  ࠡ⠭ )'),
         {318}  ('      ( 騩   㧫)'),
         {318}  ('      (ᯮ ᨬ)'),
         {320}  ('      (⮬᪨  ᪠-)'),
         {321}  ('      (ᯮ짮 ⮤ "⪨"  Microsoft Word)'),
         {322}  ('      (ᯮ짮 Int$15/Fn$4F  祭 ᪠- 맮)'),
         {323}  (' 㦥/᫮'),
         {324}  ('筮 㦥      =  '),
         {325}  ('FA-⠡ 砫 裡  =  '),
         {326}  ('BA-⠡ 砫 裡  =  '),
         {327}  ('FE-⠡ 砫 裡  =  '),
         {328}  ('BE-⠡ 砫 裡  =  '),
         {329}  ('AS-⠡ 砫 裡  =  '),
         {330}  ('ES-⠡ 砫 裡  =  '),
         {331}  ('      =  '),
         {332}  ('室  襭.'),
         {333}  (' ࠢ. ४.'),
         {334}  ('㤠祭 맮  ⠭  䫠 ⠩.'),
         {335}  ('㤠祭 맮  祭 ﭨ ⠩.'),
         {336}  (' ⠩  業 ᪮ (1=,0=): '),
         {337}  ('業 ⠩ 몫祭.'),
         {338}  ('業 ⠩ 祭,   [] = '),
         {339}  ('*** ७ ଠ  ⮩ ᪮஢ ணࠬ ***'),
         {340}  (''),
         {341}  (''),
         {342}  ('᪠        =  '),
         {343}  ('業筠           =  '),
         {344}  ('᪨            =  '),
         {345}  ('᪨               =  '),
         {346}  ('⫠ ७     =  '),
         {347}  ('   8   =  '),
         {348}  ('  16   =  '),
         {349}  (' ଠ  १ ணࠬ  ᫮.'),
         {350}  ('  ॠ.'),
         {351}  ('㤠祭 맮  祭 ଠ樨  ணࠬ.'),
         {352}  (' 譥 ॠ樨  =  '),
         {353}  (' 譥 ᨨ      =  '),
         {354}  (' 譥 ॢ     =  '),
         {355}  (' ७.ॠ樨 =  '),
         {356}  (' ७ ᨨ   =  '),
         {357}  (' ७ ॢ  =  '),
         {358}  (' ணࠬ  =  '),
         {359}  (' ணࠬ   =  '),
         {360}  (' 뢠  䥩  ணࠬ =  '),
         {361}  ('  祭  ணࠬ        =  '),
         {362}  ('᫮ ন 㭪権 (0  )     =  '),
         {363}  (' ⥪饣 ﭨ            =  '),
         {364}  (' ⥪饣 ﭨ ᪠  =  '),
         {365}  ('᫥  ﭨ             =  '),
         {366}  ('砫쭮 ᫮ "⨪  뢠"  =  '),
         {367}  (' ⠩ 業                      =  '),
         {368}  ('᫥ 稭 ⠩ 業        =  '),
         {369}  (' ᢮ ࠭⢠  =  '),
         {370}  (' ᢮ ࠭⢠   =  '),
         {371}  ('!  㫥  .'),
         {372}  ('*** ଠ  ணࠬ ***'),
         {373}  ('० '),
         {374}  ('० ᪠'),
         {375}  ('० ⠭'),
         {376}  (' 訡'),
         {377}  ('宩 ᯥ樠 ᨬ'),
         {378}  (' 室饣 室  ᪥'),
         {379}  ('⮥ ࠦ'),
         {380}  (' '),
         {381}  ('.'),
         {382}  ('몫.'),
         {383}  ('*** 㦥/᫮ ଠ ***'),
         {384}  ('  ⥫                      ,(ࠧ)'),
         {385}  ('᢮.'),
         {386}  ('.'),
         {387}  ('⨪ ᮢ 㦥:'),
         {388}  ('ᥣ = '),
         {389}  ('. = '),
         {390}  ('᢮. = '),
         {391}  ('⥪騩 = '),
         {392}  (' ⠭ ⥪饣 㦥 = '),
         {393}  (' '),
         {394}  (''),
         {395}  (''),
         {396}  (''),
         {397}  ('㤠祭 맮  ஢ 㪠⥫ ᢮ .'),
         {398}  ('   ⮣ ᫮'),
         {399}  ('⥫ ᢮   =  '),
         {400}  (' ᢮      =  '),
         {401}  ('      (ᯮ짮 ⮤ "⪨"  ண Norton Editor)'),
         {402}  (' १ࢨ஢  = '),
         {403}  (' ࠧ  ।   =  '),
         {404}  (' ᫥  ।   =  '),
         {405}  ('  ᥬ ᫮              =  '),
         {406}  ('  ᫮                  =  '),
         {407}  ('㤠祭 맮    室  ᫮.'),
         {408}  ('  祭 =  '),
         {409}  ('宥 । 짮⥫   室'),
         {410}  ('筮 ᢮ '),
         {411}  ('᫮  ᦠ⮬ ଠ'),
         {412}  ('宩 맮'),
         {413}  ('ᯥ譮 ᤥ'),
         {414}  (' ᢮ '),
         {415}  ('宩    㦥'),
         {416}  ('㦥   ⮣ '),
         {417}  (' 㭪   ॠ'),
         {418}  ('宩 ०  '),
         {419}  ('⢨⥫ ࠬ   ᢮ '),
         {420}  (' 稭 䫠  䨫'),
         {421}  ('宩   뢠'),
         {422}  ('娥 ࠬ  ப ᪠'),
         {423}  ('宩  㭪樨 権 짮⥫'),
         {424}  ('宩  㭪樨 業筮 ⠩'),
         {425}  ('宩 ଠ ப । 짮⥫'),
         {426}  ('짮⥫᪨ ᫮  ᦠ'),
         {427}  (' 孥 . ᯮ짮  .'),
         {428}  (' 砫 ᫥ ࠬ=  '),
         {429}  ('  ᫥ ࠬ =  '),
         {430}  ('宩 ᫥ ࠬ'),
         {431}  ('⠭ 業 ⠩.'),
         {432}  ('業 ⠩ 祭.'),
         {433}  ('  稭  ᪠ 業筮 ⠩.'),
         {434}  ('⢨⥫ ⨯ ᪠  ᫮  ப'),
         {435}  ('⢨⥫쭮 ﭨ ᪮ ࠬ  ப'),
         {436}  ('਩        =  '),
         {437}  (''),
         {438}  ('誮 让 ᫮,  ᢮   .'),
         {439}  ('誮  ᫮  ᫮, 㤠 -.'),
         {440}  ('室/᫮ ()     =  '),
         {441}  ('.७ () =  '),
         {442}  ('३/ᥠ ()     =  '),
         {443}  (' 뢠                  =  '),
         {444}  ('㤠祭 맮  祭 権 짮⥫  ⥪饬 㦥.'),
         {445}  ('⮢ ७       =  '),
         {446}  ('宩   ᪮ ࠬ   ப'),
         {447}  ('!$DebVIDEO!'),
         {448}  ('!$DebDOSCTL!'),
         {449}  ('!$DebCALLBACK!'),
         {450}  ('!$DebCONFIG!'),
         {451}  ('!$DebTYPIST!'),
         {452}  (' 䠩  짮⥫.'),
         {453}  ('樮. ७ =  '),
         {454}  ('*** ⪨ ࠭  짮⥫ ***'),
         {455}  ('祭:  ⥫㠫쭠 設⪠  .'),
         {456}  ('ਬ:    '),
         {457}  (' [樨]  , '),
         {458}  ('     ⭠ ( ।⢨ '''),
         {459}  (''') ᯮ  ᫠.'),
         {460}  ('   ४⥫  ࠬ ࠧ  '''),
         {461}  ('''  '''),
         {462}  ('     ।⢮  '''),
         {463}  ('   ⢨⥫ 樨 ( ய) ਢ :'),
         {464}  ('      ४.    |            祭            |   ᮣ襭'),
         {465}  ('    ⪨ ਬ:   '),
         {466}  ('| ᫮ ப  ᬮ        | '),
         {467}  ('= -'),
         {468}  ('|  䠩 㦥/᫮      |  (=祣)'),
         {469}  ('| 뢥 ⫠ ଠ    | ஢ 0 (=祣)'),
         {470}  ('| 㧨  ணࠬ   | - (='),
         {471}  ('| 㧨 -    | - (='),
         {472}  ('| 㧨             | - (='),
         {473}  ('| 㧨 ᫮         | - (='),
         {474}  ('| ⠭  ᫮ ⥪騬  |  (=祣)'),
         {475}  ('| 㤠 ᫮          |  (=祣)'),
         {476}  ('| ᯨ᮪  㦥 ᫮३ | - (='),
         {477}  ('| १ࢨ஢  ७  | '),
         {478}  ('| ⢥   ᮮ饭  | 0 (=᪨)'),
         {479}  ('|  뢠  䥩  | '),
         {480}  ('| ணࠬ  祭    | '),
         {481}  ('|  業 ⠩       | '),
         {482}  ('| . ଠ  ⮩ ᨨ   | - (='),
         {483}  ('| ଠ  १⭮    | - (='),
         {484}  ('|  䠩  짮⥫| - (='),
         {485}  ('|  ⥪ ᫮ 짮⥫ | - (='),
         {486}  ('|  ⥪饣 㦥/᫮  | - (='),
         {487}  ('|  ⨪ ⥪饣 ᫮ | - (='),
         {488}  ('| ⮢ ०  業        | - (='),
         {489}  ('| ० 樨               | - (='),
         {490}  ('| 䠪 ன        | '),
         {491}  ('| 㧠 প  ᥪ㭤        | '),
         {492}  ('| "⨪ ⠩"  뢮   | '),
         {493}  ('|  ⪨ ࠭         | 祣'),
         {494}  ('='),
         {495}  (', ='),
         {496}  ('='),
         {497}  ('[]'),
         {498}  ('[஢]'),
         {499}  ('[]'),
         {500}  ('宩  㭪樨   ⨪'),
         {501}  ('宩 㪠⥫  ⨪'),
         {502}  ('㤠祭 맮  祭  ⨪.'),
         {503}  ('㤠祭 맮  ⠭  ⨪.'),
         {504}  ('騩  ⨪   = '),
         {505}  ('  ⨪   = '),
         {506}  ('᪨ ७ =  '),
         {507}  ('| 뢥 ⨪          | - (='),
         {508}  ('|  ⨪         | - (='),
         {509}  ('| ६ ᡮ ⨪,  | '),
         {510}  ('⨪  ()   =  '),
         {511}  (' '),
         {512}  ('⠭ ਭ .'),
         {513}  (' ⨪ ᯥ譮 㦥   .'),
         {514}  (' ⨪ ᯥ譮 㦥   .'),
         {515}  (' প ⨪   ⮩ ᨨ.'),
         {516}  (' ਭ .'),
         {517}  (' ⨪   筮 .'),
         {518}  (' ⨪   孥 .'),
         {519}  ('  ᢮    ⨪.  楯    ࠧ襭.'),
         {520}  (' ।    ⨪.'),
         {521}  ('  ६  ⥪饬  ⨪.'),
         {522}  ('    ⨪   = '),
         {523}  ('   ਭ = '),
         {524}  ('  ᯮ짮  - = '),
         {525}  (' ਭ .'),
         {526}  (' 뤥    ⨪.'),
         {527}  ('⮩ 㪠⥫     ⨪.'),
         {528}  ('ﭨ ਭ            =  '),
         {529}  ('    ⨪  . =  '),
         {530}  (' ⨪          =  '),
         {531}  ('*** ଠ  ⨪  ***'),
         {532}  ('뢥 ⨪ ਭ .'),
         {533}  ('⨪ ਭ   '),
         {534}  ('騩 㪠⥫  㫥        =  '),
         {535}  ('᫮ 砫 ⨪ ⠩         =  '),
         {536}  ('᫮ ⥪ ⨪ ⠩           =  '),
         {537}  ('砫  ( ⥬)            =  '),
         {538}  ('砫쭠  ( ⥬)         =  '),
         {539}  ('᫮       =  '),
         {540}  ('⠢訥  ਭ    =  '),
         {541}  ('⨪      '),
         {542}  ('᪠ ଠ'),
         {543}  ('  ଠ樨.'),
         {544}  ('**६**   **⨪   **'),
         {545}  ('-:-   -ᥣ*-  -.-  -*.*-  -*.-'),
         {546}  ('-- ⨪ १⮢--'),
         {547}  ('-- ४⭠ ⨪  --'),
         {548}  ('-----  ----------  ------  ----------------  -----  ---------------'),
         {549}  ('㡫஢ 室'),
         {550}  (' 室'),
         {551}  (' ࠬ  ⨢ ० =  '),
         {552}  (' ࠬ  ⮬ ०   =  '),
         {553}  ('      (ᯮ짮 梥 ࠬ   ०)'),
         {554}  ('      (ࠧ襭  ॢ)'),
         {555}  (' ॢ '),
         {556}  (' 㫠    ⨪ =  '),
         {557}  ('⨪    㦥  ⢨.'),
         {558}  ('*** ଠ  ᯮ짮  ***'),
         {559}  ('ᥣ ᯮ짮  ணࠬ  묨 = '),
         {560}  (' 襣 CMB = '),
         {561}  ('業 ࠧ ᫮   = '),
         {562}  (' ᯥ譮 㤠  .'),
         {563}  ('  ⨢ ⥪騩 ᫮.'),
         {564}  ('|  ६   㦥  | '),
         {565}  ('|  室 ୠ쭮 䠩  |  (=祣)'),
         {566}  (' <'+Globals.asUseInt154F+'>  ন  ⮬ .'),
         {567}  ('      (ᯮ짮 Int$16/Fn$01,$11  䨫樨 室 ⮪)'),
         {568}  ('訡  ࠡ⪥ ࠬ   㦥.'),
         {569}  (' ६   㦥 = ')
{$ELSE}
         {019}  (asBlank),
         {020}  (asBlank),
         {021}  (asBlank),
         {022}  (asBlank),
         {023}  (asBlank),
         {024}  (asBlank),
         {025}  (asBlank),
         {026}  (asBlank),
         {027}  (asBlank),
         {028}  (asBlank),
         {029}  (asBlank),
         {030}  (asBlank),
         {031}  (asBlank),
         {032}  (asBlank),
         {033}  (asBlank),
         {034}  (asBlank),
         {035}  (asBlank),
         {036}  (asBlank),
         {037}  (asBlank),
         {038}  (asBlank),
         {039}  (asBlank),
         {040}  (asBlank),
         {041}  (asBlank),
         {042}  (asBlank),
         {043}  (asBlank),
         {044}  (asBlank),
         {045}  (asBlank),
         {046}  (asBlank),
         {047}  (asBlank),
         {048}  (asBlank),
         {049}  (asBlank),
         {050}  (asBlank),
         {051}  (asBlank),
         {052}  (asBlank),
         {053}  (asBlank),
         {054}  (asBlank),
         {055}  (asBlank),
         {056}  (asBlank),
         {057}  (asBlank),
         {058}  (asBlank),
         {059}  (asBlank),
         {060}  (asBlank),
         {061}  (asBlank),
         {062}  (asBlank),
         {063}  (asBlank),
         {064}  (asBlank),
         {065}  (asBlank),
         {066}  (asBlank),
         {067}  (asBlank),
         {068}  (asBlank),
         {069}  (asBlank),
         {060}  (asBlank),
         {071}  (asBlank),
         {072}  (asBlank),
         {073}  (asBlank),
         {074}  (asBlank),
         {075}  (asBlank),
         {076}  (asBlank),
         {077}  (asBlank),
         {078}  (asBlank),
         {079}  (asBlank),
         {080}  (asBlank),
         {081}  (asBlank),
         {082}  (asBlank),
         {083}  (asBlank),
         {084}  (asBlank),
         {085}  (asBlank),
         {086}  (asBlank),
         {087}  (asBlank),
         {088}  (asBlank),
         {089}  (asBlank),
         {090}  (asBlank),
         {091}  (asBlank),
         {092}  (asBlank),
         {093}  (asBlank),
         {094}  (asBlank),
         {095}  (asBlank),
         {096}  (asBlank),
         {097}  (asBlank),
         {098}  (asBlank),
         {099}  (asBlank),
         {100}  (asBlank),
         {101}  (asBlank),
         {102}  (asBlank),
         {103}  (asBlank),
         {104}  (asBlank),
         {105}  (asBlank),
         {106}  (asBlank),
         {107}  (asBlank),
         {108}  (asBlank),
         {109}  (asBlank),
         {110}  (asBlank),
         {111}  (asBlank),
         {112}  (asBlank),
         {113}  (asBlank),
         {114}  (asBlank),
         {115}  (asBlank),
         {116}  (asBlank),
         {117}  (asBlank),
         {118}  (asBlank),
         {119}  (asBlank),
         {120}  (asBlank),
         {121}  (asBlank),
         {122}  (asBlank),
         {123}  (asBlank),
         {124}  (asBlank),
         {125}  (asBlank),
         {126}  (asBlank),
         {127}  (asBlank),
         {128}  (asBlank),
         {129}  (asBlank),
         {130}  (asBlank),
         {131}  (asBlank),
         {132}  (asBlank),
         {133}  (asBlank),
         {134}  (asBlank),
         {135}  (asBlank),
         {136}  (asBlank),
         {137}  (asBlank),
         {138}  (asBlank),
         {139}  (asBlank),
         {140}  (asBlank),
         {141}  (asBlank),
         {142}  (asBlank),
         {143}  (asBlank),
         {144}  (asBlank),
         {145}  (asBlank),
         {146}  (asBlank),
         {147}  (asBlank),
         {148}  (asBlank),
         {149}  (asBlank),
         {150}  (asBlank),
         {151}  (asBlank),
         {152}  (asBlank),
         {153}  (asBlank),
         {154}  (asBlank),
         {155}  (asBlank),
         {156}  (asBlank),
         {157}  (asBlank),
         {158}  (asBlank),
         {159}  (asBlank),
         {160}  (asBlank),
         {161}  (asBlank),
         {162}  (asBlank),
         {163}  (asBlank),
         {164}  (asBlank),
         {165}  (asBlank),
         {166}  (asBlank),
         {167}  (asBlank),
         {168}  (asBlank),
         {169}  (asBlank),
         {170}  (asBlank),
         {171}  (asBlank),
         {172}  (asBlank),
         {173}  (asBlank),
         {174}  (asBlank),
         {175}  (asBlank),
         {176}  (asBlank),
         {177}  (asBlank),
         {178}  (asBlank),
         {179}  (asBlank),
         {180}  (asBlank),
         {181}  (asBlank),
         {182}  (asBlank),
         {183}  (asBlank),
         {184}  (asBlank),
         {185}  (asBlank),
         {186}  (asBlank),
         {187}  (asBlank),
         {188}  (asBlank),
         {189}  (asBlank),
         {190}  (asBlank),
         {191}  (asBlank),
         {192}  (asBlank),
         {193}  (asBlank),
         {194}  (asBlank),
         {195}  (asBlank),
         {196}  (asBlank),
         {197}  (asBlank),
         {198}  (asBlank),
         {199}  (asBlank),
         {200}  (asBlank),
         {201}  (asBlank),
         {202}  (asBlank),
         {203}  (asBlank),
         {204}  (asBlank),
         {205}  (asBlank),
         {206}  (asBlank),
         {207}  (asBlank),
         {208}  (asBlank),
         {209}  (asBlank),
         {210}  (asBlank),
         {211}  (asBlank),
         {222}  (asBlank),
         {213}  (asBlank),
         {214}  (asBlank),
         {215}  (asBlank),
         {216}  (asBlank),
         {217}  (asBlank),
         {218}  (asBlank),
         {219}  (asBlank),
         {220}  (asBlank),
         {221}  (asBlank),
         {222}  (asBlank),
         {223}  (asBlank),
         {224}  (asBlank),
         {225}  (asBlank),
         {226}  (asBlank),
         {227}  (asBlank),
         {228}  (asBlank),
         {229}  (asBlank),
         {230}  (asBlank),
         {231}  (asBlank),
         {232}  (asBlank),
         {233}  (asBlank),
         {234}  (asBlank),
         {235}  (asBlank),
         {236}  (asBlank),
         {237}  (asBlank),
         {238}  (asBlank),
         {239}  (asBlank),
         {240}  (asBlank),
         {241}  (asBlank),
         {242}  (asBlank),
         {243}  (asBlank),
         {244}  (asBlank),
         {245}  (asBlank),
         {246}  (asBlank),
         {247}  (asBlank),
         {248}  (asBlank),
         {249}  (asBlank),
         {250}  (asBlank),
         {251}  (asBlank),
         {252}  (asBlank),
         {253}  (asBlank),
         {254}  (asBlank),
         {255}  (asBlank),
         {256}  (asBlank),
         {257}  (asBlank),
         {258}  (asBlank),
         {259}  (asBlank),
         {260}  (asBlank),
         {261}  (asBlank),
         {262}  (asBlank),
         {263}  (asBlank),
         {264}  (asBlank),
         {265}  (asBlank),
         {266}  (asBlank),
         {267}  (asBlank),
         {268}  (asBlank),
         {269}  (asBlank),
         {270}  (asBlank),
         {271}  (asBlank),
         {272}  (asBlank),
         {273}  (asBlank),
         {274}  (asBlank),
         {275}  (asBlank),
         {276}  (asBlank),
         {277}  (asBlank),
         {278}  (asBlank),
         {279}  (asBlank),
         {280}  (asBlank),
         {281}  (asBlank),
         {282}  (asBlank),
         {283}  (asBlank),
         {284}  (asBlank),
         {285}  (asBlank),
         {286}  (asBlank),
         {287}  (asBlank),
         {288}  (asBlank),
         {289}  (asBlank),
         {290}  (asBlank),
         {291}  (asBlank),
         {292}  (asBlank),
         {293}  (asBlank),
         {294}  (asBlank),
         {295}  (asBlank),
         {296}  (asBlank),
         {297}  (asBlank),
         {298}  (asBlank),
         {299}  (asBlank),
         {300}  (asBlank),
         {301}  (asBlank),
         {302}  (asBlank),
         {303}  (asBlank),
         {304}  (asBlank),
         {305}  (asBlank),
         {306}  (asBlank),
         {307}  (asBlank),
         {308}  (asBlank),
         {309}  (asBlank),
         {310}  (asBlank),
         {311}  (asBlank),
         {312}  (asBlank),
         {313}  (asBlank),
         {314}  (asBlank),
         {315}  (asBlank),
         {316}  (asBlank),
         {317}  (asBlank),
         {318}  (asBlank),
         {319}  (asBlank),
         {320}  (asBlank),
         {321}  (asBlank),
         {322}  (asBlank),
         {323}  (asBlank),
         {324}  (asBlank),
         {325}  (asBlank),
         {326}  (asBlank),
         {327}  (asBlank),
         {328}  (asBlank),
         {329}  (asBlank),
         {330}  (asBlank),
         {331}  (asBlank),
         {332}  (asBlank),
         {333}  (asBlank),
         {334}  (asBlank),
         {335}  (asBlank),
         {336}  (asBlank),
         {337}  (asBlank),
         {338}  (asBlank),
         {339}  (asBlank),
         {340}  (asBlank),
         {341}  (asBlank),
         {342}  (asBlank),
         {343}  (asBlank),
         {344}  (asBlank),
         {345}  (asBlank),
         {346}  (asBlank),
         {347}  (asBlank),
         {348}  (asBlank),
         {349}  (asBlank),
         {350}  (asBlank),
         {351}  (asBlank),
         {352}  (asBlank),
         {353}  (asBlank),
         {354}  (asBlank),
         {355}  (asBlank),
         {356}  (asBlank),
         {357}  (asBlank),
         {358}  (asBlank),
         {359}  (asBlank),
         {360}  (asBlank),
         {361}  (asBlank),
         {362}  (asBlank),
         {363}  (asBlank),
         {364}  (asBlank),
         {365}  (asBlank),
         {366}  (asBlank),
         {367}  (asBlank),
         {368}  (asBlank),
         {369}  (asBlank),
         {370}  (asBlank),
         {371}  (asBlank),
         {372}  (asBlank),
         {373}  (asBlank),
         {374}  (asBlank),
         {375}  (asBlank),
         {376}  (asBlank),
         {377}  (asBlank),
         {378}  (asBlank),
         {379}  (asBlank),
         {380}  (asBlank),
         {381}  (asBlank),
         {382}  (asBlank),
         {383}  (asBlank),
         {384}  (asBlank),
         {385}  (asBlank),
         {386}  (asBlank),
         {387}  (asBlank),
         {388}  (asBlank),
         {389}  (asBlank),
         {390}  (asBlank),
         {391}  (asBlank),
         {392}  (asBlank),
         {393}  (asBlank),
         {394}  (asBlank),
         {395}  (asBlank),
         {396}  (asBlank),
         {397}  (asBlank),
         {398}  (asBlank),
         {399}  (asBlank),
         {400}  (asBlank),
         {401}  (asBlank),
         {402}  (asBlank),
         {403}  (asBlank),
         {404}  (asBlank),
         {405}  (asBlank),
         {406}  (asBlank),
         {407}  (asBlank),
         {408}  (asBlank),
         {409}  (asBlank),
         {410}  (asBlank),
         {411}  (asBlank),
         {412}  (asBlank),
         {413}  (asBlank),
         {414}  (asBlank),
         {415}  (asBlank),
         {416}  (asBlank),
         {417}  (asBlank),
         {418}  (asBlank),
         {419}  (asBlank),
         {420}  (asBlank),
         {421}  (asBlank),
         {422}  (asBlank),
         {423}  (asBlank),
         {424}  (asBlank),
         {425}  (asBlank),
         {426}  (asBlank),
         {427}  (asBlank),
         {428}  (asBlank),
         {429}  (asBlank),
         {430}  (asBlank),
         {431}  (asBlank),
         {432}  (asBlank),
         {433}  (asBlank),
         {434}  (asBlank),
         {435}  (asBlank),
         {436}  (asBlank),
         {437}  (asBlank),
         {438}  (asBlank),
         {439}  (asBlank),
         {440}  (asBlank),
         {441}  (asBlank),
         {442}  (asBlank),
         {443}  (asBlank),
         {444}  (asBlank),
         {445}  (asBlank),
         {446}  (asBlank),
         {447}  (asBlank),
         {448}  (asBlank),
         {449}  (asBlank),
         {450}  (asBlank),
         {451}  (asBlank),
         {452}  (asBlank),
         {453}  (asBlank),
         {454}  (asBlank),
         {455}  (asBlank),
         {456}  (asBlank),
         {457}  (asBlank),
         {458}  (asBlank),
         {459}  (asBlank),
         {460}  (asBlank),
         {461}  (asBlank),
         {462}  (asBlank),
         {463}  (asBlank),
         {464}  (asBlank),
         {465}  (asBlank),
         {466}  (asBlank),
         {467}  (asBlank),
         {468}  (asBlank),
         {469}  (asBlank),
         {470}  (asBlank),
         {471}  (asBlank),
         {472}  (asBlank),
         {473}  (asBlank),
         {474}  (asBlank),
         {475}  (asBlank),
         {476}  (asBlank),
         {477}  (asBlank),
         {478}  (asBlank),
         {479}  (asBlank),
         {480}  (asBlank),
         {481}  (asBlank),
         {482}  (asBlank),
         {483}  (asBlank),
         {484}  (asBlank),
         {485}  (asBlank),
         {486}  (asBlank),
         {487}  (asBlank),
         {488}  (asBlank),
         {489}  (asBlank),
         {490}  (asBlank),
         {491}  (asBlank),
         {492}  (asBlank),
         {493}  (asBlank),
         {494}  (asBlank),
         {495}  (asBlank),
         {496}  (asBlank),
         {497}  (asBlank),
         {498}  (asBlank),
         {499}  (asBlank),
         {500}  (asBlank),
         {501}  (asBlank),
         {502}  (asBlank),
         {503}  (asBlank),
         {504}  (asBlank),
         {505}  (asBlank),
         {506}  (asBlank),
         {507}  (asBlank),
         {508}  (asBlank),
         {509}  (asBlank),
         {510}  (asBlank),
         {511}  (asBlank),
         {512}  (asBlank),
         {513}  (asBlank),
         {514}  (asBlank),
         {515}  (asBlank),
         {516}  (asBlank),
         {517}  (asBlank),
         {518}  (asBlank),
         {519}  (asBlank),
         {520}  (asBlank),
         {521}  (asBlank),
         {522}  (asBlank),
         {523}  (asBlank),
         {524}  (asBlank),
         {525}  (asBlank),
         {526}  (asBlank),
         {527}  (asBlank),
         {528}  (asBlank),
         {529}  (asBlank),
         {530}  (asBlank),
         {531}  (asBlank),
         {532}  (asBlank),
         {533}  (asBlank),
         {534}  (asBlank),
         {535}  (asBlank),
         {536}  (asBlank),
         {537}  (asBlank),
         {538}  (asBlank),
         {539}  (asBlank),
         {540}  (asBlank),
         {541}  (asBlank),
         {542}  (asBlank),
         {543}  (asBlank),
         {544}  (asBlank),
         {545}  (asBlank),
         {546}  (asBlank),
         {547}  (asBlank),
         {548}  (asBlank),
         {549}  (asBlank),
         {550}  (asBlank),
         {551}  (asBlank),
         {552}  (asBlank),
         {553}  (asBlank),
         {554}  (asBlank),
         {555}  (asBlank),
         {556}  (asBlank),
         {557}  (asBlank),
         {558}  (asBlank),
         {559}  (asBlank),
         {560}  (asBlank),
         {561}  (asBlank),
         {562}  (asBlank),
         {563}  (asBlank),
         {564}  (asBlank),
         {565}  (asBlank),
         {566}  (asBlank),
         {567}  (asBlank),
         {568}  (asBlank),
         {569}  (asBlank)
{$ENDIF} {RusVer}
        ));


FUNCTION
   _fnsTextMessageByIndex(dwMsgIndex : System.Word) : STRING;
{*
Description.
   Extracts a text message from a table if specified index in valid range;
   displays a 'bad index' message if bad index found.
*}
BEGIN
   IF  ((dwMsgIndex > aTableIndexMax)  OR
        (dwMsgIndex < aTableIndexMin))
     THEN  dwMsgIndex := aTableIndexMin;
   {if-then}

   _fnsTextMessageByIndex := Strings.StrPas(gszMsgIdxTable[Globals.gdwCurLanguage,dwMsgIndex]);
END;
{ _fnsTextMessageByIndex }



{BEGIN}
END.
